AuxiliaryDescriptorImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model.impl

## Class AuxiliaryDescriptorImpl

- java.lang.Object
- - tv.amwa.maj.model.impl.InterchangeObjectImpl
  - - tv.amwa.maj.model.impl.EssenceDescriptorImpl
    - - tv.amwa.maj.model.impl.PhysicalDescriptorImpl
      - - tv.amwa.maj.model.impl.AuxiliaryDescriptorImpl

- All Implemented Interfaces:
    Serializable, Cloneable, MediaEntity, MetadataObject, XMLSerializable, AuxiliaryDescriptor, EssenceDescriptor, InterchangeObject, PhysicalDescriptor

      @MediaClass(uuid1=218169601,
                  uuid2=257,
                  uuid3=19968,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="AuxiliaryDescriptor",
                  description="The AuxiliaryDescriptor class specifies describes an auxiliary file essence source.",
                  symbol="AuxiliaryDescriptor")
      public class AuxiliaryDescriptorImpl
      extends PhysicalDescriptorImpl
      implements AuxiliaryDescriptor, Serializable, XMLSerializable, Cloneable

  Implements the description of an auxiliary file essence source. The type of data in the essence is given by a mime type. See the IANA register of media types.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `ObjectClassPropertyID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AuxiliaryDescriptorImpl()`
    `AuxiliaryDescriptorImpl(String mimeType)` Creates and initializes a new auxilary descriptor with the given mime type.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AuxiliaryDescriptor` | `clone()` Create a cloned copy of this interchange object.
    `String` | `getCharSet()` Gets the registered character set used by the internal and external representation of the data as per RFC 2048.
    `String` | `getMIMEType()` Gets the registered mime type of the data in the auxiliary file as per RFC 2046 (MIME media types) and RFC 2048 (MIME registration prodcedures).
    `static String` | `initializeMIMEType()`
    `void` | `setCharSet(String charSet)` Sets the registered character set used by the internal and external representation of the data as per RFC 2048.
    `void` | `setMIMEType(String mimeType)` Sets the registered mime type of the data in the auxiliary file as per RFC 2046 and RFC 2048.

    - ### Methods inherited from class tv.amwa.maj.model.impl.EssenceDescriptorImpl

      `appendLocator, appendSubDescriptor, clearLocators, clearSubDescriptors, countLocators, countSubDescriptors, getComment, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `addApplicationPlugin, appendXMLChildren, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getLinkedGenerationIDString, getObjectClass, getPersistentID, getPersistentIndex, hashCode, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setLinkedGenerationIDString, setObjectClass, setPersistentID, setPersistentIndex, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.model.EssenceDescriptor

      `appendLocator, appendSubDescriptor, clearLocators, countLocators, countSubDescriptors, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

    - ### Methods inherited from interface tv.amwa.maj.io.xml.XMLSerializable

      `appendXMLChildren, getComment`

- - ### Constructor Detail

    - #### AuxiliaryDescriptorImpl

          public AuxiliaryDescriptorImpl()

    - #### AuxiliaryDescriptorImpl

          public AuxiliaryDescriptorImpl(@AAFString
                                         String mimeType)
                                  throws NullPointerException

      Creates and initializes a new auxilary descriptor with the given mime type.

      Parameters:
        `mimeType` - Registered mimetype of the data in the auxiliary file, according to RFC 2046 (MIME Media Types) and RFC 2048 (MIME Registration Procedures).
      Throws:
        `NullPointerException` - Argument is null.

  - ### Method Detail

    - #### getCharSet

          @MediaProperty(uuid1=67699456,
                         uuid2=0,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,8},
                         definedName="CharSet",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=19986,
                         symbol="CharSet")
          public String getCharSet()
                                                                                                                                                                                                                                                                                                                                                                   throws PropertyNotPresentException

      Description copied from interface: `AuxiliaryDescriptor`

      Gets the registered character set used by the internal and external representation of the data as per RFC 2048. See the IANA register of character sets. Example: `"ISO-8859-1"`. This is an optional property.

      Specified by:
        `getCharSet` in interface `AuxiliaryDescriptor`
      Returns:
        The registered character set used by the internal and external representation of the data.
      Throws:
        `PropertyNotPresentException` - The optional character set is not present for this auxiliary descriptor.

    - #### setCharSet

          @MediaPropertySetter(value="CharSet")
          public void setCharSet(String charSet)

      Description copied from interface: `AuxiliaryDescriptor`

      Sets the registered character set used by the internal and external representation of the data as per RFC 2048. See the IANA register of character sets. Example: `"ISO-8859-1"`. Set to `null` to omit this optional property.

      Specified by:
        `setCharSet` in interface `AuxiliaryDescriptor`
      Parameters:
        `charSet` - Specifies the registered character set used by the internal and external representation of the data.

    - #### getMIMEType

          @MediaProperty(uuid1=67699201,
                         uuid2=0,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,7},
                         definedName="MIMEType",
                         aliases="MimeType",
                         typeName="UTF16String",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=19985,
                         symbol="MIMEType")
          public String getMIMEType()

      Description copied from interface: `AuxiliaryDescriptor`

      Gets the registered mime type of the data in the auxiliary file as per RFC 2046 (MIME media types) and RFC 2048 (MIME registration prodcedures).

      Specified by:
        `getMIMEType` in interface `AuxiliaryDescriptor`
      Returns:
        The registered mimetype of the data in the auxiliary file.

    - #### setMIMEType

          @MediaPropertySetter(value="MIMEType")
          public void setMIMEType(String mimeType)
                                                                  throws NullPointerException

      Description copied from interface: `AuxiliaryDescriptor`

      Sets the registered mime type of the data in the auxiliary file as per RFC 2046 and RFC 2048.

      Specified by:
        `setMIMEType` in interface `AuxiliaryDescriptor`
      Parameters:
        `mimeType` - Specifies the registered mimetype of the data in the auxiliary file.
      Throws:
        `NullPointerException` - The given mime type is `null`.

    - #### initializeMIMEType

          public static final String initializeMIMEType()

    - #### clone

          public AuxiliaryDescriptor clone()

      Description copied from interface: `InterchangeObject`

      Create a cloned copy of this interchange object.

      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `AuxiliaryDescriptor`
      Specified by:
        `clone` in interface `EssenceDescriptor`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `PhysicalDescriptor`
      Overrides:
        `clone` in class `PhysicalDescriptorImpl`
      Returns:
        Cloned copy of this interchange object.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.